﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Silanis.ESL.SDK;
using Silanis.ESL.SDK.Builder;
using System.Diagnostics;
using System.Net.Http;
using System.Net.Http.Headers;
using Newtonsoft.Json.Linq;
using System.IO;

namespace esl
{
    class PersonalLoanApplicationREST
    {
        public static void start()
        {
            string apiKey = "YOUR_API_KEY";
            string url = "https://sandbox.esignlive.com/api";

            string jsonString = "{\"type\":\"PACKAGE\",\"status\":\"SENT\",\"roles\":[{\"id\":\"Signer1\",\"type\":\"SIGNER\",\"signers\":[{\"email\":\"mail30@mailinator.com\",\"firstName\":\"John\",\"lastName\":\"Smith\",\"id\":\"Signer1\"}]}],\"name\":\"Personal Loan Application\",\"documents\":[{\"fields\":[{\"value\":\"10000\",\"name\":\"dollars\"},{\"value\":\"John Smith\",\"name\":\"full_name\"},{\"value\":\"123 Main St\",\"name\":\"address\"},{\"value\":\"New York\",\"name\":\"city\"},{\"value\":\"NY\",\"name\":\"state\"}],\"extract\":true,\"name\":\"Sample Loan Agreement\",\"id\":\"loan\",\"approvals\":[{\"role\":\"Signer1\",\"fields\":[{\"type\":\"SIGNATURE\",\"extract\":\"true\",\"subtype\":\"CAPTURE\",\"name\":\"borrower_signature\"},{\"type\":\"INPUT\",\"extract\":\"true\",\"binding\":\"{approval.signed}\",\"subtype\":\"LABEL\",\"name\":\"date\"},{\"type\":\"INPUT\",\"extract\":\"true\",\"binding\":\"{approval.signed}\",\"subtype\":\"LABEL\",\"name\":\"date2\"}]}]}]}";

            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            byte[] fileByteArray = File.ReadAllBytes("../personal-loan.pdf");
            ByteArrayContent content = new ByteArrayContent(fileByteArray);

            content.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content.Headers.ContentDisposition.Name = "\"file\"";
            content.Headers.ContentDisposition.FileName = "\"personal-loan.pdf\"";
            content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            MultipartFormDataContent form = new MultipartFormDataContent();
            form.Add(content, "\"file\"", "\"personal-loan.pdf\"");
            form.Add(jsonContent, "\"payload\"");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", apiKey);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = myClient.PostAsync(new Uri(url) + "/packages/", form).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);
        }
    }
}
